--- gcc/ubsan.c.jj	2014-03-18 10:04:06.441343729 +0100
+++ gcc/ubsan.c	2014-03-18 10:24:42.824451915 +0100
@@ -390,7 +390,7 @@ ubsan_type_descriptor (tree type, bool w
   TREE_CONSTANT (ctor) = 1;
   TREE_STATIC (ctor) = 1;
   DECL_INITIAL (decl) = ctor;
-  rest_of_decl_compilation (decl, 1, 0);
+  varpool_finalize_decl (decl);
 
   /* Save the VAR_DECL into the hash table.  */
   decl_for_type_insert (type, decl);
@@ -501,7 +501,7 @@ ubsan_create_data (const char *name, loc
   TREE_CONSTANT (ctor) = 1;
   TREE_STATIC (ctor) = 1;
   DECL_INITIAL (var) = ctor;
-  rest_of_decl_compilation (var, 1, 0);
+  varpool_finalize_decl (var);
 
   return var;
 }
--- gcc/lto/lto-lang.c.jj	2014-03-17 20:01:33.927565658 +0100
+++ gcc/lto/lto-lang.c	2014-03-18 10:25:14.141276663 +0100
@@ -1222,6 +1222,11 @@ lto_init (void)
   NAME_TYPE (long_double_type_node, "long double");
   NAME_TYPE (void_type_node, "void");
   NAME_TYPE (boolean_type_node, "bool");
+  NAME_TYPE (complex_float_type_node, "complex float");
+  NAME_TYPE (complex_double_type_node, "complex double");
+  NAME_TYPE (complex_long_double_type_node, "complex long double");
+  if (int128_integer_type_node)
+    NAME_TYPE (int128_integer_type_node, "__int128");
 #undef NAME_TYPE
 
   /* Initialize LTO-specific data structures.  */
--- gcc/testsuite/c-c++-common/ubsan/null-1.c.jj	2013-11-19 21:56:24.566416519 +0100
+++ gcc/testsuite/c-c++-common/ubsan/null-1.c	2014-03-17 13:23:46.057000209 +0100
@@ -1,7 +1,6 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=null -w" } */
 /* { dg-shouldfail "ubsan" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 int
 main (void)
--- gcc/testsuite/c-c++-common/ubsan/null-2.c.jj	2013-11-19 21:56:24.566416519 +0100
+++ gcc/testsuite/c-c++-common/ubsan/null-2.c	2014-03-17 13:23:46.060000592 +0100
@@ -1,7 +1,6 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=null -w" } */
 /* { dg-shouldfail "ubsan" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 int
 main (void)
--- gcc/testsuite/c-c++-common/ubsan/null-3.c.jj	2013-11-19 21:56:24.567416516 +0100
+++ gcc/testsuite/c-c++-common/ubsan/null-3.c	2014-03-17 13:23:46.063000958 +0100
@@ -1,7 +1,6 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=null -w" } */
 /* { dg-shouldfail "ubsan" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 int
 foo (int *p)
--- gcc/testsuite/c-c++-common/ubsan/null-4.c.jj	2013-11-19 21:56:24.567416516 +0100
+++ gcc/testsuite/c-c++-common/ubsan/null-4.c	2014-03-17 15:37:15.977422737 +0100
@@ -1,7 +1,6 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=null -w" } */
 /* { dg-shouldfail "ubsan" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 int
 main (void)
--- gcc/testsuite/c-c++-common/ubsan/null-5.c.jj	2013-11-19 21:56:24.568416515 +0100
+++ gcc/testsuite/c-c++-common/ubsan/null-5.c	2014-03-17 13:23:46.070001743 +0100
@@ -1,7 +1,6 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=null -w" } */
 /* { dg-shouldfail "ubsan" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 typedef volatile const _Complex float *T;
 
--- gcc/testsuite/c-c++-common/ubsan/null-6.c.jj	2013-11-19 21:56:24.568416515 +0100
+++ gcc/testsuite/c-c++-common/ubsan/null-6.c	2014-03-17 13:23:46.073002053 +0100
@@ -1,7 +1,6 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=null -w" } */
 /* { dg-shouldfail "ubsan" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 int
 main (void)
--- gcc/testsuite/c-c++-common/ubsan/null-7.c.jj	2013-11-19 21:56:24.568416515 +0100
+++ gcc/testsuite/c-c++-common/ubsan/null-7.c	2014-03-17 13:23:46.076002349 +0100
@@ -1,7 +1,6 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=null -w" } */
 /* { dg-shouldfail "ubsan" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 int *
 gao (void)
--- gcc/testsuite/c-c++-common/ubsan/null-8.c.jj	2013-11-19 21:56:24.569416512 +0100
+++ gcc/testsuite/c-c++-common/ubsan/null-8.c	2014-03-17 13:23:46.079002629 +0100
@@ -1,7 +1,6 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=null -w" } */
 /* { dg-shouldfail "ubsan" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 struct S {
   int i;
--- gcc/testsuite/c-c++-common/ubsan/null-9.c.jj	2013-11-19 21:56:24.569416512 +0100
+++ gcc/testsuite/c-c++-common/ubsan/null-9.c	2014-03-17 13:23:46.082002896 +0100
@@ -1,7 +1,6 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=null -w" } */
 /* { dg-shouldfail "ubsan" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 union U {
   int i;
--- gcc/testsuite/c-c++-common/ubsan/null-10.c.jj	2013-11-19 21:56:24.570416506 +0100
+++ gcc/testsuite/c-c++-common/ubsan/null-10.c	2014-03-17 13:23:46.037997317 +0100
@@ -1,7 +1,6 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=null -w" } */
 /* { dg-shouldfail "ubsan" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 int
 main (void)
--- gcc/testsuite/c-c++-common/ubsan/null-11.c.jj	2013-11-19 21:56:24.570416506 +0100
+++ gcc/testsuite/c-c++-common/ubsan/null-11.c	2014-03-17 13:23:46.040997808 +0100
@@ -1,7 +1,6 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=null -w" } */
 /* { dg-shouldfail "ubsan" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 struct S {
   int i;
--- gcc/testsuite/c-c++-common/ubsan/overflow-1.c.jj	2013-12-16 09:01:19.528694075 +0100
+++ gcc/testsuite/c-c++-common/ubsan/overflow-1.c	2014-03-17 13:23:46.115005224 +0100
@@ -1,6 +1,5 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=signed-integer-overflow" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 #ifndef ASM1
 # define ASM1(a) /* Nothing */
--- gcc/testsuite/c-c++-common/ubsan/overflow-2.c.jj	2013-12-16 09:01:19.529694084 +0100
+++ gcc/testsuite/c-c++-common/ubsan/overflow-2.c	2014-03-17 13:23:46.117005412 +0100
@@ -1,6 +1,5 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=signed-integer-overflow" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 #define ASM1(a) asm volatile ("" : "+g" (a))
 #define ASM2(a, b) asm volatile ("" : "+g" (a), "+g" (b))
--- gcc/testsuite/c-c++-common/ubsan/overflow-add-1.c.jj	2013-12-05 09:39:37.025471293 +0100
+++ gcc/testsuite/c-c++-common/ubsan/overflow-add-1.c	2014-03-17 13:23:46.129006333 +0100
@@ -1,6 +1,5 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=signed-integer-overflow -Wno-unused-variable" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 #define SCHAR_MAX __SCHAR_MAX__
 #define SHRT_MAX __SHRT_MAX__
--- gcc/testsuite/c-c++-common/ubsan/overflow-add-2.c.jj	2013-12-27 19:24:31.892788744 +0100
+++ gcc/testsuite/c-c++-common/ubsan/overflow-add-2.c	2014-03-17 13:23:46.135006670 +0100
@@ -1,6 +1,5 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=signed-integer-overflow -Wno-unused-variable" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 #define INT_MAX __INT_MAX__
 #define INT_MIN (-__INT_MAX__ - 1)
--- gcc/testsuite/c-c++-common/ubsan/overflow-int128.c.jj	2013-12-17 20:04:24.664056891 +0100
+++ gcc/testsuite/c-c++-common/ubsan/overflow-int128.c	2014-03-17 15:37:24.128376597 +0100
@@ -1,7 +1,6 @@
 /* { dg-do run } */
 /* { dg-require-effective-target int128 } */
 /* { dg-options "-fsanitize=signed-integer-overflow" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 /* 2^127 - 1 */
 #define INT128_MAX (__int128) (((unsigned __int128) 1 << ((__SIZEOF_INT128__ * __CHAR_BIT__) - 1)) - 1)
--- gcc/testsuite/c-c++-common/ubsan/overflow-mul-1.c.jj	2013-12-05 09:39:37.027471281 +0100
+++ gcc/testsuite/c-c++-common/ubsan/overflow-mul-1.c	2014-03-17 13:23:46.140006896 +0100
@@ -1,6 +1,5 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=signed-integer-overflow -Wno-unused-variable" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 #define SCHAR_MAX __SCHAR_MAX__
 #define SHRT_MAX __SHRT_MAX__
--- gcc/testsuite/c-c++-common/ubsan/overflow-mul-2.c.jj	2013-12-27 19:24:31.907788669 +0100
+++ gcc/testsuite/c-c++-common/ubsan/overflow-mul-2.c	2014-03-17 13:23:46.143007014 +0100
@@ -1,6 +1,5 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=signed-integer-overflow -Wno-unused-variable" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 #define INT_MAX __INT_MAX__
 #define LONG_MAX __LONG_MAX__
--- gcc/testsuite/c-c++-common/ubsan/overflow-mul-3.c.jj	2013-12-16 19:45:37.820560165 +0100
+++ gcc/testsuite/c-c++-common/ubsan/overflow-mul-3.c	2014-03-17 13:23:46.180008229 +0100
@@ -1,6 +1,5 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=signed-integer-overflow" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 __attribute__((noinline, noclone)) long long
 mul (long long x, long long y)
--- gcc/testsuite/c-c++-common/ubsan/overflow-mul-4.c.jj	2013-12-27 19:24:31.907788669 +0100
+++ gcc/testsuite/c-c++-common/ubsan/overflow-mul-4.c	2014-03-17 14:16:29.242042830 +0100
@@ -1,6 +1,6 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=signed-integer-overflow" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
+
 
 int
 main ()
--- gcc/testsuite/c-c++-common/ubsan/overflow-negate-1.c.jj	2013-12-27 19:24:31.908788664 +0100
+++ gcc/testsuite/c-c++-common/ubsan/overflow-negate-1.c	2014-03-17 13:23:46.187008132 +0100
@@ -1,6 +1,5 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=signed-integer-overflow -Wno-unused-variable" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 #define INT_MIN (-__INT_MAX__ - 1)
 #define LONG_MIN (-__LONG_MAX__ - 1L)
--- gcc/testsuite/c-c++-common/ubsan/overflow-negate-2.c.jj	2014-02-17 10:05:30.397163210 +0100
+++ gcc/testsuite/c-c++-common/ubsan/overflow-negate-2.c	2014-03-17 13:23:46.190008087 +0100
@@ -1,6 +1,5 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=signed-integer-overflow -Wno-unused-variable" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 #define SCHAR_MIN (-__SCHAR_MAX__ - 1)
 #define SHRT_MIN (-__SHRT_MAX__ - 1)
--- gcc/testsuite/c-c++-common/ubsan/overflow-sub-1.c.jj	2013-12-05 09:39:37.026471287 +0100
+++ gcc/testsuite/c-c++-common/ubsan/overflow-sub-1.c	2014-03-17 13:23:46.193008058 +0100
@@ -1,6 +1,5 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=signed-integer-overflow -Wno-unused-variable" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 #define SCHAR_MAX __SCHAR_MAX__
 #define SCHAR_MIN (-__SCHAR_MAX__ - 1)
--- gcc/testsuite/c-c++-common/ubsan/overflow-sub-2.c.jj	2013-12-27 19:24:31.906788674 +0100
+++ gcc/testsuite/c-c++-common/ubsan/overflow-sub-2.c	2014-03-17 13:23:46.196008044 +0100
@@ -1,6 +1,5 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=signed-integer-overflow -Wno-unused-variable" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 #define INT_MAX __INT_MAX__
 #define INT_MIN (-__INT_MAX__ - 1)
--- gcc/testsuite/c-c++-common/ubsan/pr59333.c.jj	2013-12-27 19:24:31.924788585 +0100
+++ gcc/testsuite/c-c++-common/ubsan/pr59333.c	2014-03-17 13:23:46.199008026 +0100
@@ -1,6 +1,5 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=undefined" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 long long int __attribute__ ((noinline, noclone))
 foo (long long int i, long long int j)
--- gcc/testsuite/c-c++-common/ubsan/pr59503.c.jj	2013-12-16 09:01:19.528694075 +0100
+++ gcc/testsuite/c-c++-common/ubsan/pr59503.c	2014-03-17 13:23:46.202008009 +0100
@@ -1,6 +1,5 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=signed-integer-overflow" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 int
 main (void)
--- gcc/testsuite/c-c++-common/ubsan/pr59667.c.jj	2014-01-08 17:45:05.985539847 +0100
+++ gcc/testsuite/c-c++-common/ubsan/pr59667.c	2014-03-17 13:23:46.205007992 +0100
@@ -1,7 +1,6 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=undefined" } */
 /* { dg-shouldfail "ubsan" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 int
 main (void)
--- gcc/testsuite/c-c++-common/ubsan/undefined-1.c.jj	2013-11-27 12:10:46.208899823 +0100
+++ gcc/testsuite/c-c++-common/ubsan/undefined-1.c	2014-03-17 13:23:46.208007974 +0100
@@ -1,6 +1,5 @@
 /* { dg-do run } */
 /* { dg-options "-fsanitize=undefined" } */
-/* { dg-skip-if "" { *-*-* } { "-flto" } { "" } } */
 
 int
 foo (int x, int y)
--- gcc/testsuite/g++.dg/ubsan/pr59250.C.jj	2013-11-25 18:30:19.000000000 +0100
+++ gcc/testsuite/g++.dg/ubsan/pr59250.C	2014-03-17 13:24:55.456612415 +0100
@@ -1,7 +1,6 @@
 // PR sanitizer/59250
 // { dg-do compile }
 // { dg-options "-fsanitize=undefined" }
-// { dg-skip-if "" { *-*-* } { "-flto" } { "" } }
 
 struct E {
  int i;
--- gcc/testsuite/g++.dg/ubsan/pr59306.C.jj	2013-11-27 18:02:44.000000000 +0100
+++ gcc/testsuite/g++.dg/ubsan/pr59306.C	2014-03-17 13:24:52.950626701 +0100
@@ -1,6 +1,5 @@
 // { dg-do compile }
 // { dg-options "-fsanitize=undefined" }
-// { dg-skip-if "" { *-*-* } { "-flto" } { "" } }
 
 class A {
   void bar (void (A::*) (int));